import React from "react";
export declare type Error = {
    code: number;
    message: string;
} | null;
export declare type Message = {
    title?: string;
    message: string;
} | null;
export default function useIndicator(): {
    error: Error;
    warning: Message;
    success: Message;
    info: Message;
    requestQuantity: number;
    setError: React.Dispatch<React.SetStateAction<Error>>;
    setWarning: React.Dispatch<React.SetStateAction<Message>>;
    setSuccess: (message: Message) => void;
    setInfo: (message: Message) => void;
    clearError: () => void;
    clearInfo: () => void;
    clearSuccess: () => void;
    clearWarning: () => void;
    startRequest: () => void;
    endRequest: () => void;
    clearRequest: () => void;
};
