'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var tapable = require('tapable');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

function debugHooks(obj, includes) {
    return new Proxy(obj, {
        get: function (target, name, receiver) {
            if (name === 'tap' &&
                target[name] &&
                typeof target[name] === 'function') {
                return function (option, func) {
                    var newF = function () {
                        var rest = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            rest[_i] = arguments[_i];
                        }
                        var methodName = option;
                        console.group(methodName);
                        console.log.apply(console, __spread(rest));
                        console.groupEnd();
                        return func.apply(void 0, __spread(rest));
                    };
                    return target[name](option, newF);
                };
            }
            else if (target[name] !== null &&
                typeof target[name] === 'object' &&
                includes.includes(name)) {
                return debugHooks(target[name], includes);
            }
            else {
                return Reflect.get(target, name, receiver);
            }
        },
    });
}

function isMenuGroup(item) {
    if (item.subs) {
        return true;
    }
    return false;
}
var HooksProvider = /** @class */ (function () {
    function HooksProvider(plugins, logHooks) {
        var _this = this;
        this.hooks = {
            afterMenusFetched: new tapable.SyncHook(['appKey', 'menus']),
            afterPageLoaded: new tapable.SyncHook(['appKey', 'pageKey', 'props']),
            afterPageUnloaded: new tapable.SyncHook(['appKey', 'pageKey', 'props']),
            afterComponentLoaded: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'compnent',
                'props',
            ]),
            afterComponentUnloaded: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'compnent',
                'props',
            ]),
            afterFormSelectFetched: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'formKey',
                'formItems',
                'selectKey',
                'selectData',
            ]),
            afterTableDataSourceFetched: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'tableKey',
                'column',
                'dataSource',
            ]),
            beforeFormSelectFetched: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'formKey',
                'formItems',
                'selectKey',
            ]),
            beforeTableDataSourceFetched: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'tableKey',
                'columns',
            ]),
            beforeFormItemsFinalization: new tapable.SyncHook(['appKey', 'pageKey', 'formKey', 'items']),
            beforeTableColumnFinalization: new tapable.SyncHook([
                'appKey',
                'pageKey',
                'tableKey',
                'column',
            ]),
            beforeButtonClick: new tapable.SyncHook(['appKey', 'pageKey', 'buttonKey']),
            beforeFormSubmit: new tapable.SyncHook(['appKey', 'pageKey', 'formKey', 'values']),
            beforeCheckboxChange: new tapable.SyncHook(['appKey', 'pageKey', 'checkbokKey', 'value'])
        };
        if (Array.isArray(plugins)) {
            plugins.forEach(function (plugin) {
                if (logHooks && logHooks.length > 0) {
                    plugin.apply(debugHooks(_this.hooks, logHooks));
                }
                else {
                    plugin.apply(_this.hooks);
                }
            });
        }
    }
    return HooksProvider;
}());
var initialConfig = {
    appKey: 'YOUR_APP_KEY',
    appTitle: 'YOUR_APP_TITLE',
    menus: []
};
var common = { ui: null, config: initialConfig, hooks: new HooksProvider([]).hooks };
var App = React.createContext(common);
function AppProvider(props) {
    return React.createElement(App.Provider, { value: { ui: props.ui, config: props.config, hooks: new HooksProvider(props.plugins, props.debugHooks).hooks } }, props.children);
}

function _Layout(props) {
    var app = React.useContext(App);
    var Comp = app.ui ? app.ui.Layout : null;
    return (React.createElement(Comp, { style: __assign({}, props.style), className: props.className, config: props.config, hide: props.hide }));
}
var Layout = React.memo(_Layout);

function _Page(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'page', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'page', props);
        };
    }, []);
    var Comp = app.ui ? app.ui.Page : null;
    return (React.createElement(Comp, { style: __assign({}, props.style) }, props.children));
}
var Page = React.memo(_Page);

function createContainer(useHook) {
    var Context = React.createContext(null);
    function Provider(props) {
        var value = useHook(props.initialState);
        return React.createElement(Context.Provider, { value: value }, props.children);
    }
    function useContainer() {
        var value = React.useContext(Context);
        if (value === null) {
            throw new Error("Component must be wrapped with <Container.Provider>");
        }
        return value;
    }
    return { Provider: Provider, useContainer: useContainer };
}

function useIndicator() {
    var _a = __read(React.useState(null), 2), error = _a[0], setError = _a[1];
    var _b = __read(React.useState(null), 2), warning = _b[0], setWarning = _b[1];
    var _c = __read(React.useState(null), 2), success = _c[0], _setSuccess = _c[1];
    var _d = __read(React.useState(null), 2), info = _d[0], _setInfo = _d[1];
    var _e = __read(React.useState(0), 2), requestQuantity = _e[0], _setRequestQuantity = _e[1];
    var clearSuccess = function () { return _setSuccess(null); };
    var clearInfo = function () { return _setInfo(null); };
    var clearWarning = function () { return setWarning(null); };
    var clearError = function () { return setError(null); };
    var clearRequest = function () { return _setRequestQuantity(0); };
    var setSuccess = function (message) {
        _setSuccess(message);
        setTimeout(function () {
            clearSuccess();
        }, 3000);
    };
    var setInfo = function (message) {
        _setInfo(message);
        setTimeout(function () {
            clearInfo();
        }, 3000);
    };
    var startRequest = React.useCallback(function () {
        _setRequestQuantity(function (prevQuantity) { return prevQuantity + 1; });
    }, []);
    var endRequest = React.useCallback(function () {
        _setRequestQuantity(function (prevQuantity) { return prevQuantity - 1; });
    }, []);
    return {
        error: error,
        warning: warning,
        success: success,
        info: info,
        requestQuantity: requestQuantity,
        setError: setError,
        setWarning: setWarning,
        setSuccess: setSuccess,
        setInfo: setInfo,
        clearError: clearError,
        clearInfo: clearInfo,
        clearSuccess: clearSuccess,
        clearWarning: clearWarning,
        startRequest: startRequest,
        endRequest: endRequest,
        clearRequest: clearRequest
    };
}

function useFilter() {
    var _a = __read(React.useState({}), 2), _filter = _a[0], _setFilter = _a[1];
    var getFilter = function (pageKey, tableKey) {
        var f = _filter[pageKey + "_" + tableKey];
        return f;
    };
    var setFilter = function (pageKey, tableKey, values) {
        var _a;
        values.resetCurrentPage = true;
        _setFilter(__assign({}, _filter, (_a = {}, _a[pageKey + "_" + tableKey] = values, _a)));
    };
    return { getFilter: getFilter, setFilter: setFilter };
}

function useModal() {
    var _a = __read(React.useState({}), 2), _modalShow = _a[0], _setModalShow = _a[1];
    var isShowModal = function (pageKey, modalKey) {
        var f = _modalShow[pageKey + "_" + modalKey];
        return f;
    };
    var hideModal = function (pageKey, modalKey) {
        var _a;
        _setModalShow(__assign({}, _modalShow, (_a = {}, _a[pageKey + "_" + modalKey] = false, _a)));
    };
    var showModal = function (pageKey, modalKey) {
        var _a;
        _setModalShow(__assign({}, _modalShow, (_a = {}, _a[pageKey + "_" + modalKey] = true, _a)));
    };
    return { isShowModal: isShowModal, hideModal: hideModal, showModal: showModal };
}

function useParams() {
    var _a = __read(React.useState({}), 2), _params = _a[0], _setParams = _a[1];
    var getParams = function (pageKey, sectionKey) {
        var f = _params[pageKey + "_" + sectionKey];
        return f;
    };
    var setParams = function (pageKey, sectionKey, value) {
        var _a;
        _setParams(__assign({}, _params, (_a = {}, _a[pageKey + "_" + sectionKey] = value, _a)));
    };
    return { getParams: getParams, setParams: setParams };
}

function usePage() {
    var indicator = useIndicator();
    var filter = useFilter();
    var modal = useModal();
    var params = useParams();
    return __assign({}, indicator, filter, modal, params);
}

var Pages = createContainer(usePage);

var href = window.location.href;
function fetch2(url, options, loginUrl) {
    if (loginUrl === void 0) { loginUrl = 'https://docoder.com'; }
    var realUrl = url;
    var opt = options || {};
    opt.credentials = opt.credentials || 'include';
    return fetch(realUrl, opt)
        .then(function (response) { return response.json(); })
        .then(function (json) {
        if (json.code === 40003 || json.code === 201 || json.code === 401) {
            var return_login = loginUrl + '?returnUrl=' + encodeURIComponent(href);
            window.location.replace(return_login);
            throw new Error('Please Login First!');
        }
        else {
            return json;
        }
    });
}
function GET(url, loginUrl) {
    return __awaiter(this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, REQ('get', url, loginUrl)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    error_1 = _a.sent();
                    throw error_1;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function POST(url, loginUrl, body) {
    return __awaiter(this, void 0, void 0, function () {
        var error_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, REQ('post', url, loginUrl, body)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    error_2 = _a.sent();
                    throw error_2;
                case 3: return [2 /*return*/];
            }
        });
    });
}
function REQ(method, url, loginUrl, body) {
    return __awaiter(this, void 0, void 0, function () {
        var data, error_3;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, fetch2(url, method === 'post' ? {
                            method: 'POST',
                            headers: {
                                'Accept': 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify(body),
                        } : null, loginUrl)];
                case 1:
                    data = _a.sent();
                    return [2 /*return*/, data];
                case 2:
                    error_3 = _a.sent();
                    throw error_3;
                case 3: return [2 /*return*/];
            }
        });
    });
}

function useGET() {
    var _this = this;
    var app = React.useContext(App);
    var _a = Pages.useContainer(), setError = _a.setError, startRequest = _a.startRequest, endRequest = _a.endRequest;
    var send = React.useCallback(function (url, filter) { return __awaiter(_this, void 0, void 0, function () {
        var u, paramsStr_1, data, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    startRequest();
                    u = url;
                    if (filter && Object.keys(filter).length > 0) {
                        paramsStr_1 = '?';
                        Object.keys(filter).forEach(function (k) {
                            paramsStr_1 += k + "=" + filter[k] + "&";
                        });
                        u = "" + url + paramsStr_1.slice(0, -1);
                    }
                    return [4 /*yield*/, GET(u, app.config.loginUrl)];
                case 1:
                    data = _a.sent();
                    endRequest();
                    //TODO: DOC
                    if (data.code === 0 && data.data) {
                        return [2 /*return*/, data];
                    }
                    else {
                        setError(data);
                    }
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    setError(error_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/, null];
            }
        });
    }); }, []);
    return send;
}

function getValueByKeypath(modal, keypath) {
    var keys = keypath.split('.').map(function (s) { return s.trim(); }).filter(function (s) { return s; });
    var value = modal;
    for (var index = 0; index < keys.length; index++) {
        var key = keys[index];
        value = value[key];
    }
    return value;
}

function useTable(pageKey, tableKey, columns, meta) {
    var app = React.useContext(App);
    var get = useGET();
    var filter = Pages.useContainer().getFilter(pageKey, tableKey);
    var dataType = pageKey.toUpperCase() + "_" + tableKey.toUpperCase() + "_TABLE_DATA_FETCHED";
    var pageType = pageKey.toUpperCase() + "_" + tableKey.toUpperCase() + "_TABLE_SET_CURRENT_PAGE";
    var sizeType = pageKey.toUpperCase() + "_" + tableKey.toUpperCase() + "_TABLE_SET_PAGE_SIZE";
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case dataType:
                return __assign({}, state, { dataSource: action.dataSource, total: action.total });
            case pageType:
                return __assign({}, state, { currentPage: action.page });
            case sizeType:
                return __assign({}, state, { pageSize: action.size });
            default:
                throw new Error();
        }
    }, { dataSource: [], currentPage: 1, total: 0, pageSize: meta.pageSize || 20 }), 2), state = _a[0], dispatch = _a[1];
    var currentPage = state.currentPage, pageSize = state.pageSize;
    var setCurrentPage = React.useCallback(function (page) {
        dispatch({ type: pageType, page: page });
    }, []);
    var setPageSize = React.useCallback(function (size) {
        dispatch({ type: sizeType, size: size });
    }, []);
    if (filter && filter.resetCurrentPage) {
        dispatch({ type: pageType, page: 1 });
        delete filter.resetCurrentPage;
    }
    React.useEffect(function () {
        var mounted = true;
        function fetchTableData(p, t, u) {
            return __awaiter(this, void 0, void 0, function () {
                var dataSource, totalCount, currentPageKey, pageSizeKey, listKey, totalKey, result, list, total;
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            app.hooks.beforeTableDataSourceFetched.call(app.config.appKey, p, t, columns);
                            dataSource = [];
                            totalCount = 0;
                            if (!meta.data) return [3 /*break*/, 1];
                            dataSource = meta.data.filter(function (d) {
                                if (!filter || !filter.type)
                                    return true;
                                else
                                    return d.typeId === filter.type;
                            });
                            totalCount = dataSource.length;
                            return [3 /*break*/, 3];
                        case 1:
                            currentPageKey = 'currentPage';
                            pageSizeKey = 'pageSize';
                            listKey = 'list';
                            totalKey = 'total';
                            if (meta.alias) {
                                if (meta.alias.currentPage)
                                    currentPageKey = meta.alias.currentPage;
                                if (meta.alias.pageSize)
                                    pageSizeKey = meta.alias.pageSize;
                                if (meta.alias.list)
                                    listKey = meta.alias.list;
                                if (meta.alias.total)
                                    totalKey = meta.alias.total;
                            }
                            return [4 /*yield*/, get(u, __assign({}, filter, (_a = {}, _a[currentPageKey] = currentPage, _a[pageSizeKey] = pageSize, _a)))];
                        case 2:
                            result = _b.sent();
                            list = getValueByKeypath(result.data, listKey);
                            total = getValueByKeypath(result.data, totalKey);
                            if (result && result.data && list && total) {
                                dataSource = list;
                                totalCount = total;
                            }
                            _b.label = 3;
                        case 3:
                            app.hooks.afterTableDataSourceFetched.call(app.config.appKey, p, t, columns, dataSource);
                            //TODO: doc: better to config "id: true", or use index key
                            if (mounted)
                                dispatch({ type: dataType, dataSource: dataSource.map(function (d, i) { return (__assign({}, d, { key: i })); }), total: totalCount });
                            return [2 /*return*/];
                    }
                });
            });
        }
        fetchTableData(pageKey, tableKey, meta.url);
        return function () { mounted = false; };
    }, [pageKey, tableKey, meta.url, filter, currentPage, pageSize]);
    return __assign({}, state, { setCurrentPage: setCurrentPage, setPageSize: setPageSize });
}

function _Table(props) {
    var _this = this;
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'table', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'table', props);
        };
    }, []);
    var _a = Pages.useContainer(), showModal = _a.showModal, setParams = _a.setParams;
    var keyItem = props.columns.find(function (c) { return !!c.id; });
    var rowKey = keyItem ? keyItem.key : 'key';
    var get = useGET();
    var columns = props.columns.map(function (c) {
        var actions = c.actions;
        if (c.actions && c.actions.length > 0) {
            actions = c.actions.map(function (a) { return ({
                key: a.key,
                label: a.meta.label,
                callback: function (text, record, index) { return __awaiter(_this, void 0, void 0, function () {
                    var result, params, aParams_1, keys;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                result = null;
                                if (!a.meta.url) return [3 /*break*/, 2];
                                if (!(a.meta.method === 'GET' || !a.meta.method)) return [3 /*break*/, 2];
                                return [4 /*yield*/, get(a.meta.url)];
                            case 1:
                                result = (_a.sent()) || [];
                                _a.label = 2;
                            case 2:
                                params = null;
                                if (a.meta.params && Object.keys(a.meta.params).length > 0) {
                                    aParams_1 = a.meta.params;
                                    params = {};
                                    keys = Object.keys(a.meta.params);
                                    keys.forEach(function (k) {
                                        var value = aParams_1[k];
                                        if (value.startsWith('$.')) {
                                            params[k] = record[value.split('.')[1]];
                                        }
                                        else if (value.startsWith('$#') && result) {
                                            params[k] = result.data[value.split('#')[1]];
                                        }
                                        else {
                                            params[k] = value;
                                        }
                                    });
                                }
                                if (a.meta.modal && a.meta.modal.length > 0) {
                                    if (params)
                                        setParams(props.pageKey, a.meta.modal, params);
                                    showModal(props.pageKey, a.meta.modal);
                                }
                                return [2 /*return*/];
                        }
                    });
                }); },
                show: true,
                modal: a.meta ? a.meta.modal : null
            }); });
        }
        app.hooks.beforeTableColumnFinalization.call(app.config.appKey, props.pageKey, props.tableKey, c);
        return __assign({}, c, { actions: actions, dataIndex: c.key, title: c.label });
    });
    var _b = useTable(props.pageKey, props.tableKey, columns, props.meta), dataSource = _b.dataSource, currentPage = _b.currentPage, total = _b.total, pageSize = _b.pageSize, setCurrentPage = _b.setCurrentPage, setPageSize = _b.setPageSize;
    var Comp = app.ui ? app.ui.Table : null;
    return (React.createElement(Comp, { style: __assign({}, props.style), appKey: app.config.appKey, pageKey: props.pageKey, className: props.className, rowKey: rowKey, columns: columns, dataSource: dataSource, onPageChange: function (page, pSize) {
            if (page !== currentPage)
                setCurrentPage(page);
            if (pSize !== pageSize)
                setPageSize(pSize);
        }, pagination: {
            current: currentPage,
            total: total,
            pageSize: pageSize,
            position: 'both'
        } }));
}
var Table = React.memo(_Table);

function useSelect(pageKey, formKey, items) {
    var app = React.useContext(App);
    var get = useGET();
    var type = pageKey.toUpperCase() + "_" + formKey.toUpperCase() + "_SELECT_DATA_FETCHED";
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case type:
                return __assign({}, state, { data: action.data });
            default:
                throw new Error();
        }
    }, { data: items }), 2), state = _a[0], dispatch = _a[1];
    React.useEffect(function () {
        var mounted = true;
        function fetchSelectData(itemKey, itemUrl, itemAlias) {
            return __awaiter(this, void 0, void 0, function () {
                var result, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            app.hooks.beforeFormSelectFetched.call(app.config.appKey, pageKey, formKey, items, itemKey);
                            return [4 /*yield*/, get(itemUrl)];
                        case 1:
                            result = (_a.sent()) || [];
                            app.hooks.afterFormSelectFetched.call(app.config.appKey, pageKey, formKey, items, itemKey, result.data);
                            data = result.data;
                            if (itemAlias) {
                                data = data.map(function (d) { return ({
                                    label: getValueByKeypath(d, itemAlias.label || 'label'),
                                    value: getValueByKeypath(d, itemAlias.value || 'value')
                                }); });
                            }
                            return [2 /*return*/, data];
                    }
                });
            });
        }
        function handleSelect(itms) {
            return __awaiter(this, void 0, void 0, function () {
                var selectItems;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            selectItems = itms.filter(function (i) { return i.type === 'select'; });
                            if (selectItems.length <= 0)
                                return [2 /*return*/]; // 阻止无 select 的 items 造成一次重复渲染
                            return [4 /*yield*/, Promise.all(selectItems.map(function (i) { return __awaiter(_this, void 0, void 0, function () {
                                    var originalUrl_1, refItem, _a;
                                    var _this = this;
                                    return __generator(this, function (_b) {
                                        switch (_b.label) {
                                            case 0:
                                                i.meta.showSearch = true;
                                                if (!(i.meta && i.meta.data)) return [3 /*break*/, 1];
                                                return [2 /*return*/, i];
                                            case 1:
                                                if (!(i.meta && i.meta.ref)) return [3 /*break*/, 2];
                                                if (i.meta.refData) {
                                                    i.meta.data = function (refValue) { return i.meta.refData[refValue]; };
                                                    return [2 /*return*/, i];
                                                }
                                                else if (i.meta.url) {
                                                    originalUrl_1 = i.meta.url;
                                                    refItem = itms.find(function (it) { return it.key === i.meta.ref; });
                                                    refItem.onChange = function (value) { return __awaiter(_this, void 0, void 0, function () {
                                                        var url, selectData;
                                                        return __generator(this, function (_a) {
                                                            switch (_a.label) {
                                                                case 0:
                                                                    url = originalUrl_1.replace('$refValue', value);
                                                                    return [4 /*yield*/, fetchSelectData(i.key, url, i.meta.alias)];
                                                                case 1:
                                                                    selectData = _a.sent();
                                                                    i.meta.data = selectData;
                                                                    console.log('----->>>', type);
                                                                    if (mounted)
                                                                        dispatch({ type: type, data: itms });
                                                                    return [2 /*return*/];
                                                            }
                                                        });
                                                    }); };
                                                    i.meta.data = [];
                                                    return [2 /*return*/, i];
                                                }
                                                return [3 /*break*/, 5];
                                            case 2:
                                                if (!(i.meta && i.meta.url)) return [3 /*break*/, 4];
                                                _a = i.meta;
                                                return [4 /*yield*/, fetchSelectData(i.key, i.meta.url, i.meta.alias)];
                                            case 3:
                                                _a.data = _b.sent();
                                                return [2 /*return*/, i];
                                            case 4: throw new Error('The JSON format is not valid!');
                                            case 5: return [2 /*return*/];
                                        }
                                    });
                                }); }))];
                        case 1:
                            _a.sent();
                            if (mounted)
                                dispatch({ type: type, data: itms });
                            return [2 /*return*/];
                    }
                });
            });
        }
        handleSelect(items);
        return function () { mounted = false; };
    }, [pageKey, formKey, items]);
    return state.data;
}

function usePOST() {
    var _this = this;
    var app = React.useContext(App);
    var _a = Pages.useContainer(), setError = _a.setError, startRequest = _a.startRequest, endRequest = _a.endRequest;
    var send = React.useCallback(function (url, body) { return __awaiter(_this, void 0, void 0, function () {
        var data, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    startRequest();
                    return [4 /*yield*/, POST(url, app.config.loginUrl, body)];
                case 1:
                    data = _a.sent();
                    endRequest();
                    //TODO: DOC
                    if (data.code === 0 && data.data) {
                        return [2 /*return*/, data];
                    }
                    else {
                        setError(data);
                    }
                    return [3 /*break*/, 3];
                case 2:
                    error_1 = _a.sent();
                    setError(error_1);
                    return [3 /*break*/, 3];
                case 3: return [2 /*return*/, null];
            }
        });
    }); }, []);
    return send;
}

function useSubmit(url, method, pageKey, modalKey) {
    var _this = this;
    var get = useGET();
    var post = usePOST();
    var hideModal = Pages.useContainer().hideModal;
    var send = React.useCallback(function (values) { return __awaiter(_this, void 0, void 0, function () {
        var result;
        return __generator(this, function (_a) {
            result = null;
            if (method && method.toLowerCase() === 'post') {
                result = post(url, values);
            }
            else {
                result = get(url, values);
            }
            if (result && modalKey) {
                hideModal(pageKey, modalKey);
            }
            return [2 /*return*/];
        });
    }); }, []);
    return send;
}

function _Form(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'form', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'form', props);
        };
    }, []);
    var _a = Pages.useContainer(), getParams = _a.getParams, setFilter = _a.setFilter;
    var items = useSelect(props.pageKey, props.formKey, props.items);
    items.forEach(function (i) {
        if (typeof i.data === 'string' && i.data.startsWith('$.')) {
            if (props.meta.modal) {
                var params = getParams(props.pageKey, props.meta.modal);
                if (params) {
                    var valueKey = i.data.split('.')[1];
                    i.data = params[valueKey] || [];
                }
                else {
                    i.data = [];
                }
            }
        }
        app.hooks.beforeFormItemsFinalization.call(app.config.appKey, props.pageKey, props.formKey, items);
    });
    var submit = useSubmit(props.meta.url, props.meta.method, props.pageKey, props.meta.modal);
    var Comp = app.ui ? app.ui.Form : null;
    return (React.createElement(Comp, { style: __assign({}, props.style), inModal: props.meta.modal && props.meta.modal.length > 0, className: props.className, items: items, columnsCount: props.columnsCount, onSubmit: function (values) {
            app.hooks.beforeFormSubmit.call(app.config.appKey, props.pageKey, props.formKey);
            var keys = items.filter(function (i) { return !i.disabled; }).map(function (i) { return i.key; });
            var keyFilterAliasMap = {};
            items.filter(function (i) { return i.alias; }).forEach(function (i) {
                keyFilterAliasMap[i.key] = i.alias;
            });
            var newValues = {};
            Object.keys(values).forEach(function (k) {
                if (values[k] && keys.includes(k)) {
                    var vk = keyFilterAliasMap[k] || k;
                    newValues[vk] = values[k];
                }
            });
            if (props.meta.filter) {
                setFilter(props.pageKey, props.meta.filter, newValues);
            }
            else {
                submit(newValues);
            }
        } }));
}
var Form = React.memo(_Form);

function _Alert(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, 'global', 'alert', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, 'global', 'alert', props);
        };
    }, []);
    var Comp = app.ui ? app.ui.Alert : null;
    return (React.createElement(Comp, { type: props.type, message: props.message, description: props.description, onClose: props.onClose }));
}
var Alert = React.memo(_Alert);

function _Loading(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, 'global', 'loading', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, 'global', 'loading', props);
        };
    }, []);
    var Comp = app.ui ? app.ui.Loading : null;
    return (React.createElement(Comp, { show: props.show, type: props.type, timeout: props.timeout }));
}
var Loading = React.memo(_Loading);

function _Indicator() {
    var _a = Pages.useContainer(), error = _a.error, warning = _a.warning, success = _a.success, info = _a.info, requestQuantity = _a.requestQuantity, clearError = _a.clearError, clearInfo = _a.clearInfo, clearSuccess = _a.clearSuccess, clearWarning = _a.clearWarning, clearRequest = _a.clearRequest;
    var errorAlert = error && (React.createElement(Alert, { type: "error", message: error.code ? '操作失败' : '发生错误', description: error.message || JSON.stringify(error), onClose: clearError }));
    var warningAlert = warning && (React.createElement(Alert, { type: "warning", message: warning.title, description: warning.message, onClose: clearWarning }));
    var infoAlert = info && (React.createElement(Alert, { type: "info", message: info.title, description: info.message, onClose: clearInfo }));
    var successAlert = success && (React.createElement(Alert, { type: "success", message: success.title, description: success.message, onClose: clearSuccess }));
    return (React.createElement(React.Fragment, null,
        errorAlert,
        warningAlert,
        infoAlert,
        successAlert,
        React.createElement(Loading, { show: requestQuantity > 0, type: "overall", timeout: clearRequest })));
}
var Indicator = React.memo(_Indicator);

function _Button(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'button', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'button', props);
        };
    }, []);
    var showModal = Pages.useContainer().showModal;
    var Comp = app.ui ? app.ui.Button : null;
    return (React.createElement(Comp, __assign({ style: __assign({}, props.style) }, props.meta, { onClick: function () {
            app.hooks.beforeButtonClick.call(app.config.appKey, props.pageKey, props.buttonKey);
            if (props.meta.modal && props.meta.modal.length > 0) {
                showModal(props.pageKey, props.meta.modal);
            }
        } })));
}
var Button = React.memo(_Button);

function _Modal(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'modal', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'modal', props);
        };
    }, []);
    var _a = Pages.useContainer(), hideModal = _a.hideModal, isShowModal = _a.isShowModal, getParams = _a.getParams;
    var Comp = app.ui ? app.ui.Modal : null;
    var newTitle = props.title;
    if (props.title) {
        if (props.title.startsWith('$.')) {
            var params = getParams(props.pageKey, props.modalKey);
            if (params) {
                var valueKey = props.title.split('.')[1];
                newTitle = params[valueKey];
            }
        }
        else {
            var reg = /{\$\.([^{}]*)}/g;
            if (reg.test(props.title)) {
                newTitle = props.title.replace(reg, function (match, p1) {
                    var valueKey = p1.trim();
                    var params = getParams(props.pageKey, props.modalKey);
                    if (params) {
                        return params[valueKey];
                    }
                    return valueKey;
                });
            }
        }
    }
    return (React.createElement(Comp, { style: { display: 'none' }, visible: isShowModal(props.pageKey, props.modalKey), title: newTitle, width: props.width, onCancel: function () {
            hideModal(props.pageKey, props.modalKey);
        } },
        React.createElement(Stack, { pageKey: props.pageKey, items: props.contens, direction: "vertical", stackKey: props.pageKey + "_" + props.modalKey + "_main_stack" })));
}
var Modal = React.memo(_Modal);

function _Checkbox(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'checkbox', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'checkbox', props);
        };
    }, []);
    var setParams = Pages.useContainer().setParams;
    var Comp = app.ui ? app.ui.Checkbox : null;
    return (React.createElement(Comp, { style: __assign({}, props.style), title: props.meta.label, onChange: function (value) {
            app.hooks.beforeCheckboxChange.call(app.config.appKey, props.pageKey, props.checkboxKey, value);
            if (props.meta.params && props.meta.params.set) {
                setParams(props.pageKey, props.checkboxKey, { checked: value.target.checked });
            }
        } }));
}
var Checkbox = React.memo(_Checkbox);

function _Stack(props) {
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterComponentLoaded.call(app.config.appKey, props.pageKey, 'stack', props);
        return function () {
            app.hooks.afterComponentUnloaded.call(app.config.appKey, props.pageKey, 'stack', props);
        };
    }, []);
    var vertical = props.direction === 'vertical';
    return (React.createElement("div", { style: __assign({ display: 'flex', flexDirection: vertical ? 'column' : 'row' }, props.style) }, props.items.map(function (c) {
        switch (c.type) {
            case 'Table':
                return (React.createElement(Table, { pageKey: props.pageKey, tableKey: c.key, style: vertical ? { marginBottom: 20 } : { marginRight: 10 }, key: c.key, columns: c.items, meta: c.meta }));
            case 'Form':
                return (React.createElement(Form, { pageKey: props.pageKey, formKey: c.key, style: vertical ? { marginBottom: 20 } : { marginRight: 10 }, key: c.key, items: c.items, meta: c.meta, columnsCount: c.meta.columnsCount }));
            case 'Stack':
                return (React.createElement(Stack, { key: c.key, pageKey: props.pageKey, stackKey: c.key, items: c.items, direction: c.meta.direction, style: vertical ? { marginBottom: 20 } : { marginRight: 10 } }));
            case 'Button':
                return (React.createElement(Button, { key: c.key, pageKey: props.pageKey, buttonKey: c.key, meta: c.meta, style: vertical ? { marginBottom: 20 } : { marginRight: 10 } }));
            case 'Modal':
                return (React.createElement(Modal, { key: c.key, pageKey: props.pageKey, modalKey: c.key, contens: c.items, title: c.meta.label, width: c.meta.width }));
            case 'Checkbox':
                return (React.createElement(Checkbox, { key: c.key, pageKey: props.pageKey, checkboxKey: c.key, meta: c.meta, style: vertical ? { marginBottom: 20 } : { marginRight: 10 } }));
            default:
                return null;
        }
    })));
}
var Stack = React.memo(_Stack);

function inIframe() {
    try {
        return window.self !== window.top;
    }
    catch (e) {
        return true;
    }
}

function _Index() {
    var hide = inIframe();
    var app = React.useContext(App);
    return (React.createElement(Layout, { config: app.config, hide: hide }));
}
var Index = React.memo(_Index);

function PageContainer(props) {
    // console.log('>>>>PAGE>>>>', props)
    var app = React.useContext(App);
    React.useEffect(function () {
        app.hooks.afterPageLoaded.call(app.config.appKey, pageKey, props);
        return function () {
            app.hooks.afterPageUnloaded.call(app.config.appKey, pageKey, props);
        };
    }, []);
    var get = useGET();
    var type = "PAGE_JSON_FETCHED";
    var _a = __read(React.useReducer(function (state, action) {
        switch (action.type) {
            case type:
                return __assign({}, state, { data: action.data });
            default:
                throw new Error();
        }
    }, { data: props.pageJSON || [] }), 2), state = _a[0], dispatch = _a[1];
    React.useEffect(function () {
        function fetchPageJson(url) {
            return __awaiter(this, void 0, void 0, function () {
                var data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, get(url)];
                        case 1:
                            data = _a.sent();
                            dispatch({ type: type, data: data });
                            return [2 /*return*/];
                    }
                });
            });
        }
        if ((!props.pageJSON || props.pageJSON.length <= 0) && props.pageAPI) {
            fetchPageJson(props.pageAPI + "?page=" + props.pageKey);
        }
    }, []);
    var pageKey = props.pageKey;
    return React.useMemo(function () { return (React.createElement(Page, { pageKey: pageKey, style: { padding: 20, background: 'white' } },
        React.createElement(Stack, { pageKey: pageKey, items: state.data, direction: "vertical", stackKey: pageKey + "_main_stack" }),
        React.createElement(Indicator, null))); }, [pageKey, state]);
}
var Page$1 = React.memo(PageContainer);

function isEntryPropsWithAPI(item) {
    if (item.pageAPI) {
        return true;
    }
    return false;
}
function _Entry(props) {
    var pageKey = props.pageKey;
    var pageAPI = undefined;
    var pageJSON = undefined;
    if (isEntryPropsWithAPI(props)) {
        pageAPI = props.pageAPI;
    }
    else {
        pageJSON = props.pageJSON;
    }
    return (React.createElement(Pages.Provider, null,
        React.createElement(Page$1, { pageKey: pageKey, pageAPI: pageAPI, pageJSON: pageJSON })));
}
var Entry = React.memo(_Entry);

var Kitten = /** @class */ (function () {
    function Kitten(ui, config, plugins, debugHooks) {
        this.ui = ui;
        this.config = config;
        this.plugins = plugins;
        this.debugHooks = debugHooks;
    }
    Kitten.prototype.render = function (renderer, dom) {
        renderer.render(React.createElement(AppProvider, { ui: this.ui, config: this.config, plugins: this.plugins, debugHooks: this.debugHooks },
            React.createElement(Index, null)), dom, function () {
        });
    };
    return Kitten;
}());

exports.Entry = Entry;
exports.Kitten = Kitten;
exports.isEntryPropsWithAPI = isEntryPropsWithAPI;
exports.isMenuGroup = isMenuGroup;
//# sourceMappingURL=index.js.map
